#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include "MersenneTwister.h"
using namespace std;

MTRand rand1;

double function(double x)
{
	return (x * sin(x*x) - (1-x) * sin(1-x*x));
}

int main()
{
	const int monte_carlo_steps = 10000;
	double x_boundary = 1;
	double zero = 0.61360;
	double area_d_prime = (x_boundary-zero)*function(x_boundary); //Rectangle
	double inner_points = 0;

	for(int i = 0; i < monte_carlo_steps; i++)
	{
		double randX = zero+rand1.rand(x_boundary-zero); //Random point within rectangle
		double randY = rand1.rand(function(x_boundary));

		if(randY <= function(randX))
			inner_points++;
	}
	long double estimate = (inner_points/monte_carlo_steps) * area_d_prime;

	x_boundary = zero;
	area_d_prime = (x_boundary)*function(0); //Rectangle
	inner_points = 0;

	for(int i = 0; i < monte_carlo_steps; i++)
	{
		double randX = rand1.rand(x_boundary); //Random point within rectangle
		double randY = rand1.rand(function(0));

		if(randY >= function(randX))
			inner_points++;
	}
	estimate += (inner_points/monte_carlo_steps) * area_d_prime;

	cout << "Monte-Carlo Estimate: " << estimate << endl;
	system("PAUSE");
	return 0;
}